window.onload = () => {
  let url_string = window.location.href;
  let url = new URL(url_string);
  let locale = url.searchParams.get("locale");
  let user = url.searchParams.get("user");
  let risk = url.searchParams.get("risk");
  let nr = url.searchParams.get("nr");
  setPoem(locale, user, risk, nr);
};

function setPoem(locale, user, risk, nr) {
  let region;
  if (locale == 'et') {
    region = 'et-EE';
  } else if (locale == 'en') {
    region = 'en-GB';
  } else {
    region = 'ru-RU';
  }

  let dot = locale == 'et' ? ',' : '.';

  document.getElementById('print-datetime').innerHTML = new Date(Date.now()).toLocaleString(region);
  document.getElementById('print-geo_l').innerHTML = '59°25\'58' + dot + '0" ' + lang.north[locale];
  document.getElementById('print-geo_r').innerHTML = '24°42\'19' + dot + '2" ' + lang.east[locale];
  document.getElementById('print-name').innerHTML = '<span class="bold">' + lang.memory1[locale] + " " + user + '</span><div class="print-small-text">' + lang.instruct[locale] + '</div>';
  document.getElementById('print-title').innerHTML = poems[risk][locale][nr].title;
  document.getElementById('print-poetry').innerHTML += poems[risk][locale][nr].poem;
  document.getElementById('print-credit').innerHTML = poems[risk][locale][nr].author;
  document.getElementById('print-instructions').innerHTML = lang.instructions[locale];
  document.getElementById('print-thanks').innerHTML = '<span class="bold">' + lang.thanks[locale] + ' ' + lang.visit[locale] + '</span>';
  window.print();
  setTimeout(() => { window.close() }, 1250);
}